catalog:
  title: Caffe Deep Learning

templates:
- patches
- github
- cmake-cpp
- base

variables:
  description: >-
    Caffe is a deep learning framework made with expression, speed,
    and modularity in mind. It is developed by Berkeley AI Research
    (BAIR) and by community contributors
  keywords:
  - machine learning
  - deep learning
  recipe.maintainer:
  - flier@techfak.uni-bielefeld.de

  github.user: BVLC
  github.project: caffe

  branches:
  - master

  extra-requires:
  - cmake: opencv-plus-contrib-cuda
  - freestyle: cuda
  - freestyle: cudnn
  - '@{next-value|[]}'

  platform-requires:
    ubuntu:
      packages:
      - protobuf-compiler
      - libprotobuf-dev
      - libleveldb-dev
      - libsnappy-dev
      - libhdf5-serial-dev
      - libboost-all-dev
      - libatlas-base-dev
      - libopenblas-dev
      - libleveldb-dev
      - liblmdb-dev
      - libgoogle-glog-dev
      - libgflags-dev
      - python-numpy
      - '@{next-value|[]}'

  cmake.options:
  - CMAKE_BUILD_TYPE=Release
  - CUDA_ARCH_NAME=${cudagen}
  - CUDA_TOOLKIT_ROOT_DIR=${toolkit.dir}
  - CUDA_HOST_COMPILER=${cuda.host.compiler|\$(which g++)}
  - '@{next-value|[]}'

versions:
- name: pepper-robocup
  variables:
    branch: master
    commit: 379a3ba2d5421a6ac05afa4239c30739cc79f7b0

- name: hash-18.05
  variables:
    commit: 864520713a4c5ffae7382ced5d34e4cadc608473

- name: openpose-fix
  variables:
    repository: https://github.com/CMU-Perceptual-Computing-Lab/caffe.git
    branch: master

- name: openpose-stable
  variables:
    repository: https://github.com/CMU-Perceptual-Computing-Lab/caffe.git
    commit: b5ede488952e40861e84e51a9f9fd8fe2395cc8a

- name: hash-18.09
  variables:
    commit: 99bd99795dcdf0b1d3086a8d67ab1782a8a08383

- name: nvcc11
  variables:
    branch: "1.0"
    patches.diff-strings:
      - !b!literal-include patches/caffe_nvcc_c++11.patch
      - !b!literal-include patches/caffe_cudnn8.patch

    extra-requires:
    - nature: program
      target: protoc
    - nature: cmake
      target: opencv-plus-contrib-cuda
    - nature: cmake
      target: opencv
    - nature: freestyle
      target: cuda
    - nature: freestyle
      target: cudnn

- name: cv4
  variables:
    branch: master-custom
    github.user: cepiross

    cmake.options:
    - '@{next-value|[]}'
    - CUDA_ARCH_NAME=Manual
    - CUDA_ARCH_BIN="60 61 62"
    - CUDA_ARCH_PTX=""

- name: cudnn8
  variables:
      github.user: artyom-beilis
      branch: fixes_for_cudnn8_bvlc_master

- name: Qengineering
  variables:
      github.user: Qengineering
      branch: ssd

      patches.diff-strings:
        - !b!literal-include ../projects/patches/caffe_cudnn8.patch